#!/usr/bin/perl

sub sys { print($_[0],"\n"); system($_[0])}

# wget -c http://dds.cr.usgs.gov/srtm/version2_1/SRTM3/Eurasia/N{4{5,6,7,8,9},50,51}E0{06,07,08,09,10,11,12,13,14,15}.hgt.zip

@ns = (45..51);
@es = (6..15);


for $zip (glob "*.zip") {
	$zip =~ /(N(\d+)E(\d+))\.hgt\.zip/;
	$file = $1; $n = $2; $e = $3;

	unless (-e "$file.grd") {
		sys("unzip $zip");
		sys(sprintf("GMT xyz2grd %s.hgt -R%d/%d/%d/%d -I3c -N-32768 -ZTLhw -G%s.grd",
			$file, $e, $e+1, $n, $n+1, $file));
		sys("GMT grd2xyz $file.grd >$file.txt");
		sys(sprintf("GMT surface $file.txt -R$file.grd -T0.35 -G$file.grd"));
		unlink("$file.hgt");
		unlink("$file.txt");
	}
}

for $n (@ns) {
	sys(sprintf("GMT grdpaste N%dE006.grd N%dE007.grd -G%dtmp.grd",$n,$n,$n));
	for $e (@es) {
		next if ($e<8);
		sys(sprintf("GMT grdpaste %dtmp.grd N%dE%03d.grd -G%dtmp.grd",$n,$n,$e,$n));
	};
}

sys("GMT grdpaste 45tmp.grd 46tmp.grd -Gtmp.grd");
for $n (@ns) {
	next if ($n<47);
	sys(sprintf("GMT grdpaste tmp.grd %dtmp.grd -Gtmp.grd",$n));
}
rename("tmp.grd","height.grd");

unlink for glob("*tmp.grd");
unlink("tmp.txt");

